routes/web.php
<?php

use App\Http\Controllers\CategorieController;
use App\Http\controllers\ProduitController;
use App\Http\Controllers\HomeController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/',[HomeController::class,"index"])->name('home.index');
Route::post('/panier/commander/save',[HomeController::class,"storeClientCommande"])->name('home.storeClientCommande');
Route::get('/panier',[HomeController::class,"show_panier"])->name('home.panier');
Route::get('/panier/commander',[HomeController::class,"commander"])->name('home.commander');
Route::get('/panier/clear',[HomeController::class,"clear"])->name('home.clear');
Route::post('panier/add/{id}',[HomeController::class,"add"])->name('home.add');
Route::delete('panier/delete/{id}',[HomeController::class,"delete"])->name('home.delete');
Route::resource("categories",CategorieController::class);
Route::resource("produits",ProduitController::class);

app/Models/Produit.php
<?php

namespace App\Models;

use App\Models\Categorie;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Produit extends Model
{
    use HasFactory;
    protected $fillable =[
        'designation',
        'prix_u',
        'quantite_stock',
        'categorie_id',
        'photo',
    ];
    public function categorie(){
       return  $this->belongsTo(Categorie::class);
    }
}

app/Http/Controllers/ProduitController.php
<?php

namespace App\Http\Controllers;
use App\Models\produit;
use Illuminate\Http\Request;

class ProduitController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(Request $request)
    {
    
       
        // return view("produits.index",compact('produits'));
       
        $designation = $request->query('designation');
        $prix_min = $request->query('prix_min');
        $prix_max = $request->query('prix_max');
        $categorie_id = $request->query('categorie_id');
        $query = Produit::query();
        if ($designation) {
            $query->where('designation', 'like', '%' . $designation . '%');
        }
        if($categorie_id){
            $query->where('categorie_id', '=', $categorie_id );
        }
    
        if ($prix_min) {
            $query->where('prix_u', '>=', $prix_min);
        }
        if ($prix_max) {
            $query->where('prix_u', '<=', $prix_max);
        }
    
        $nbr_produits =count($query->get()) ;
        $produits=Produit::paginate(15);
       
         return view("produits.index",compact('produits','designation','prix_min','prix_max','categorie_id','nbr_produits'));
       
       
    
    }
        
        
   

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('produits.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $data=$request->validate([
            'designation'=>'required|unique:categories,designation',
            'prix_u'=>'required',
            'quantite_stock'=>'required',
            'categorie_id'=>'required',
            'photo'=>'required|image|mimes:png,jpg,jpeg,svg|max:2048',
        ]);
        
        $data['photo'] = $request -> file('photo')->store('produit','public');
        Produit::create($data); 
        return  redirect()->route('produits.index');
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        $pro=Produit::find($id);
        
        return view('produits.show')->with("pro",$pro);
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(string $id)
    {
        $pro=Produit::find($id);
        return view('produits.edit',compact('pro'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        $data=$request->validate([
            'designation'=>'required|unique:produits,designation,'.$id,
            'prix_u'=>'required',
            'quantite_stock'=>'required',
            'categorie_id'=>'required',
            'photo'=>'required|image|mimes:png,jpg,jpeg,svg|max:2048',
        ]);
        $data['photo'] = $request -> file('photo')->store('produit','public');
        $pro=Produit::find($id);
        $pro->update($data);
        return redirect()->route('produits.index');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        Produit::destroy($id);
        return  redirect()->route('produits.index');
    }

    
}

resources/views/produits/create.blade.php
@extends('layouts.admin')
@section('title', 'Ajouter un produit')
@section('content')
    <div class="container my-4">
        <h1 class="display-4 text-center">Créer un nouvel produit</h1>

        <form action="{{ route('produits.store') }}" enctype="multipart/form-data" method="POST" class="mx-auto">
            @csrf

            <div class="mb-3 row">
                <label for="designation" class="col-sm-3 col-form-label">Designation</label>
                <div class="col-sm-9">
                    <input type="text" name="designation" id="designation" class="form-control" value="{{ old('designation') }}">
                </div>
            </div>

            <div class="mb-3 row">
                <label for="prix_u" class="col-sm-3 col-form-label">Prix unitaire</label>
                <div class="col-sm-9">
                    <input type="text" name="prix_u" id="prix_u" class="form-control" value="{{ old('prix_u') }}">
                </div>
            </div>

            <div class="mb-3 row">
                <label for="quantite_stock" class="col-sm-3 col-form-label">Quantité en stock</label>
                <div class="col-sm-9">
                    <input type="text" name="quantite_stock" id="quantite_stock" class="form-control" value="{{ old('quantite_stock') }}">
                </div>
            </div>

            <div class="mb-3 row">
                <label for="categorie_id" class="col-sm-3 col-form-label">Categorie ID</label>
                <div class="col-sm-9">
                    <input type="text" name="categorie_id" id="categorie_id" class="form-control" value="{{ old('categorie_id') }}">
                </div>
            </div>

            <div class="mb-3 row">
                <label for="photo" class="col-sm-3 col-form-label">Photo</label>
                <div class="col-sm-9">
                    <input type="file" name="photo" id="photo" class="form-control">
                </div>
            </div>

            <div class="mb-3 row">
                <div class="col-sm-9 offset-sm-3">
                    <input type="submit" value="Ajouter" class="btn btn-primary">
                </div>
            </div>
        </form>

        @if($errors->any())
            <div class="alert alert-danger mt-4">
                <ul>
                    @foreach($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif
    </div>
@endsection

resources/views/produits/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    <style>

    </style>
</head>
<body>
    @extends('layouts.admin')
    @section('title', 'Modifier un produit')
    @section('content')
        <div class="container my-4">
            <h1 class="display-4 text-center">Modifier le produit</h1>
    
            <form action="{{ route('produits.update', ['produit' => $pro->id]) }}" method="POST" enctype="multipart/form-data" class="mx-auto">
                @csrf
                @method('PUT')
    
                <div class="mb-3 row">
                    <label for="designation" class="col-sm-3 col-form-label">Designation</label>
                    <div class="col-sm-9">
                        <input type="text" name="designation" id="designation" class="form-control" value="{{ old('designation', $pro->designation) }}">
                    </div>
                </div>
    
                <div class="mb-3 row">
                    <label for="prix_u" class="col-sm-3 col-form-label">Prix unitaire</label>
                    <div class="col-sm-9">
                        <input type="text" name="prix_u" id="prix_u" class="form-control" value="{{ old('prix_u', $pro->prix_u) }}">
                    </div>
                </div>
    
                <div class="mb-3 row">
                    <label for="quantite_stock" class="col-sm-3 col-form-label">Quantité en stock</label>
                    <div class="col-sm-9">
                        <input type="text" name="quantite_stock" id="quantite_stock" class="form-control" value="{{ old('quantite_stock', $pro->quantite_stock) }}">
                    </div>
                </div>
    
                <div class="mb-3 row">
                    <label for="categorie_id" class="col-sm-3 col-form-label">Categorie ID</label>
                    <div class="col-sm-9">
                        <input type="text" name="categorie_id" id="categorie_id" class="form-control" value="{{ old('categorie_id', $pro->categorie_id) }}">
                    </div>
                </div>
    
                <div class="mb-3 row">
                    <label for="photo" class="col-sm-3 col-form-label">Photo</label>
                    <div class="col-sm-9">
                        <input type="file" name="photo" id="photo" class="form-control">
                    </div>
                </div>
    
                <div class="mb-3 row">
                    <div class="col-sm-9 offset-sm-3">
                        <input type="submit" value="Modifier" class="btn btn-primary">
                    </div>
                </div>
            </form>
    
            @if($errors->any())
                <div class="alert alert-danger mt-4">
                    <ul>
                        @foreach($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif
        </div>
    @endsection
    
</body>
</html>

resources/views/produits/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/all.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/all.min.css">

  <title>Document</title>
</head>
<body>

@extends('layouts.admin')
@section('title', 'Gestion des produits')
@section('content')
    <div class="container mt-4">
      <h1>rechercher des produits</h1>
      <form action="{{ route('produits.index') }}" method="GET" class="mb-3">
        @csrf
        <div class="row">
            <div class="col-md-3 mb-3">
                <label for="categorie_id" class="form-label">Search by Category ID</label>
                <input type="text" name="categorie_id" class="form-control" placeholder="Enter category ID..."
                    value="{{ old('categorie_id', $categorie_id) }}">
            </div>
            <div class="col-md-3 mb-3">
                <label for="prix_max" class="form-label">Search by Max Price</label>
                <input type="text" name="prix_max" class="form-control" placeholder="Enter max price..."
                    value="{{ old('prix_max', $prix_max) }}">
            </div>
            <div class="col-md-3 mb-3">
                <label for="prix_min" class="form-label">Search by Min Price</label>
                <input type="text" name="prix_min" class="form-control" placeholder="Enter min price..."
                    value="{{ old('prix_min', $prix_min) }}">
            </div>
            <div class="col-md-3 mb-3">
                <label for="designation" class="form-label">Search by Designation</label>
                <input type="text" name="designation" class="form-control" placeholder="Enter designation..."
                    value="{{ old('designation', $designation) }}">
            </div>
        </div>
        <button type="submit" class="btn btn-primary mt-2">Search</button>
    </form>
    
        <h1>Liste des produits</h1>
    <div><h4>total des produits : {{ $nbr_produits}}</h4></div>

        <a href="{{ route('produits.create') }}" class="btn btn-primary mb-3">Ajouter un nouveau produit</a>

        <div class="table-responsive">
          <table class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Designation</th>
                    <th>prix_u</th>
                    <th>quantite_stock</th>
                    <th>categorie_id</th>
                    <th colspan="3">Actions</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($produits as $pro)
                    <tr>
                      
                        <td>{{ $pro->id }}</td>
                        <td>{{ $pro->designation }}</td>
                        <td>{{ $pro->prix_u }}</td>
                        <td>{{ $pro->quantite_stock }}</td>
                        <td>{{ $pro->categorie_id }}</td>
                        <td><a href="{{ route('produits.show', ["produit" => $pro->id]) }}"
                                class="btn btn-primary">Details</a></td>
                        <td><a href="{{ route('produits.edit', ["produit" => $pro->id]) }}"
                                class="btn btn-success">Modifier</a></td>
                        <td>
                            <form action="{{ route('produits.destroy', ["produit" => $pro->id]) }}" method="POST">
                                @method('DELETE')
                                @csrf
                                <button type="submit" class="btn btn-danger"
                                    onclick="return confirm('Voulez-vous supprimer ce produit?')">Supprimer</button>
                            </form>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>
        </div>
       
        <div class="d-flex justify-content-center">
                  {{ $produits->links() }}
         </div>
@endsection
</body>
</html>

resources/views/produits/show.blade.php
@extends('layouts.admin')

@section('title', 'Détail d\'un produit')

@section('content')
    <a href="{{ route('produits.index') }}" enctype="multipart/form-data" class="btn btn-primary mb-3">Retourner vers la liste des produits</a>
    
    <div class="card">
        <div class="card-header">
            <h1 class="card-title">Détail du produit Num {{ $pro->id }}</h1>
        </div>
        <div class="card-body">
            <dl class="row">
                <dt class="col-sm-3">Designation:</dt>
                <dd class="col-sm-9">{{ $pro->designation }}</dd>

                <dt class="col-sm-3">Prix unitaire:</dt>
                <dd class="col-sm-9">{{ $pro->prix_u }}</dd>

                <dt class="col-sm-3">Quantité en stock:</dt>
                <dd class="col-sm-9">{{ $pro->quantite_stock }}</dd>

                <dt class="col-sm-3">Catégorie ID:</dt>
                <dd class="col-sm-9">{{ $pro->categorie_id }}</dd>
                @if ($pro->photo)
                <img src="{{asset('storage/'. $pro->photo)}}" style="width: 200px" alt="photo du produit">
                @else
                    <p>no photo available</p>
                @endif
            </dl>
        </div>
    </div>
@endsection